{----------------------------------------------------------------------------}
{                                                                            }
{                            LOADER Version 2.0                              }
{                  Copyright (C) 1994-95 By The GodFather                    }
{                                                                            }
{----------------------------------------------------------------------------}
{                       Last corection - 17 July 1995                        }
{----------------------------------------------------------------------------}

{$M, 1024, 0, 4096}

USES Dos, Crt, Screen, Keybord, Windows, Buttons, TextFont;

CONST
  evDialogBack   = 9;     cDialogBack   = 7;
  evButtonBack   = 144;   cButtonBack   = 112;
  evButtonFace   = 112;   cButtonFace   = 32;
  evButtonSelect = 241;   cButtonSelect = 47;
  Ld = '   ';
  Ak = '  ';
  Ns = '  ';
  Ex = '  LOADER';

VAR
  Name: STRING;
  TempNumb: Integer;
  MainButtons: PBCollection;
  OKShad  : Boolean;
  DialogBack,
  ButtonBack,
  ButtonShadow,
  ButtonFace,
  ButtonSelect  : Byte;

{$F+}
PROCEDURE UpdateField( VAR Key: Word );
VAR
  FNL: Byte;

 PROCEDURE WriteName;
 BEGIN
   GotoXY( 24, 6 );
   TextAttr := 7;
   Write( Name );
 END;

BEGIN
  FNL := Length( Name );
  IF FNL < 3 THEN IF Key IN [48..57] THEN Insert( Chr(Key), Name, FNL );
  IF FNL > 1 THEN IF Key = kbBSpace  THEN Delete( Name, FNL - 1, 1 );
  WriteName;
END;
{$F-}

FUNCTION DialogBox( Min,
                    Max: Byte;
                    VAR Result: Byte;
                    Title: STRING ) : Boolean;
LABEL Again;
VAR
  YN: PBCollection;
  M1,
  M2: STRING;
  Code: Integer;

BEGIN
  DialogBox := False;
  Str( Min, M1 );
  Str( Max, M2 );
  YN := New( PBCollection, Init( 2, 1 ) );
  WITH YN^ DO
  BEGIN
    Insert( New( PButton, Init('    OK    ', ' ', 10, 9 ,ButtonFace, ButtonBack,0,ButtonSelect )));
    Insert( New( PButton, Init('      ', ' ', 30, 9 ,ButtonFace, ButtonBack,0,ButtonSelect )));
  END;
  MkWin( 16, 8, 50, 11, 15, DialogBack, OKShad, cyrDouble, Title );
  Dec( TextAttr );
  Writeln;
  Writeln;
  WriteCStr(50, True, '   ('+M1+'..'+M2+'):');
  Writeln;
  Writeln;
Again:
  Name := '[    ]';
  TextAttr := 7;
  GotoXY( 22, 6 ); Write( Name );
  Name := ' ';
  PressedHook := @UpdateField;
  YN^.Choose( 0 );
  PressedHook := NIL;
  DefaultSettings;
  IF NOT (YN^.EscPressed) AND (YN^.ButtonNumb <> 1) THEN
  BEGIN
    Delete( Name, Length( Name ), 1 );
    Val( Name, Result, Code );
    IF (Result < Min) OR (Result > Max) THEN GOTO Again;
    Dispose( YN, Done );
    DialogBox := True;
  END;
  RmWin;
END;

PROCEDURE InfoBox( S: STRING; A: Byte );
VAR
  OK: PBCollection;

BEGIN
  OK := New( PBCollection, Init( 6, 1 ) );
  OK^.Insert( New( PButton, Init('    OK    ', ' ', 21, 6, 112, 64, 0, 241 )));
  MkWin( 14, 9, 52, 8, A, 0, OKShad, cyrDouble, '  ');
  Writeln(#13#10);
  Dec( TextAttr );
  WriteCStr( 52, False, S );
  OK^.Choose( 0 );
  Dispose( OK, Done );
  RmWin;
END;

FUNCTION FindFile( FileName: STRING ) : Boolean;
VAR
  F: FILE;

BEGIN
  FindFile := True;
  Assign( F, FileName );
  {$I-}
    Reset( F );
  {$I+}
   IF IOResult <> 0 THEN
   BEGIN
     InfoBox( '    ' + FileName, 79 );
     FindFile := False;
     Exit;
   END;
   Close( F );
END;

PROCEDURE Run( FileName, Params: STRING );
VAR
  F: FILE;

BEGIN
  RmWin;
  Dispose( MainButtons, Done );
  TextAttr := 7;
  Load8x16;
  Cursor( On );
  SetBlink( True );
  SwapVectors;
  Exec( FileName, Params );
  SwapVectors;
  IF DosError <> 0 THEN Writeln(' Error executing ' + Filename );
  Halt( 0 );
END;

PROCEDURE InitDesktop;
BEGIN
  LoadFont( Cyrilic );
  CheckBreak := False;
  SetKeyboardSpeed( 0 );
  Cursor( Off );
  SetBlink( False );
  MkWin( 11, 1, 60, 2, White, Blue, False, CyrSingle, '');
  Dec( TextAttr );
  WriteCStr(60, False, 'LOADER Version 2.0 By The GodFather' );
END;

PROCEDURE InitButtons;
BEGIN
  MainButtons := New( PBCollection, Init( 8, 1 ) );
  WITH MainButtons^ DO
  BEGIN
    Insert( New( PButton, Init('     Prince Of Persia 1     ', Ak, 4, 2 ,ButtonFace, ButtonBack,
      Attr( Yellow, DialogBack ), ButtonSelect )));
    Insert( New( PButton, Init('     Wing Commander 1-2     ', Ns, 4, 4 ,ButtonFace, ButtonBack,
      Attr( Yellow, DialogBack ), ButtonSelect )));
    Insert( New( PButton, Init('     Commander Keen 4-6     ', Ld, 4, 6 ,ButtonFace, ButtonBack,
      Attr( Yellow, DialogBack ), ButtonSelect )));
    Insert( New( PButton, Init('       Wolfenstein 3D       ', Ld, 4, 8 ,ButtonFace, ButtonBack,
      Attr( Yellow, DialogBack ), ButtonSelect )));
    Insert( New( PButton, Init('      Spear Of Destiny      ', Ld, 4, 10,ButtonFace, ButtonBack,
      Attr( Yellow, DialogBack ), ButtonSelect )));
    Insert( New( PButton, Init('         Down Rider         ', Ld, 4, 12,ButtonFace, ButtonBack,
      Attr( Yellow, DialogBack ), ButtonSelect )));
    Insert( New( PButton, Init('          Doom 1-2          ', Ld, 4, 14,ButtonFace, ButtonBack,
      Attr( Yellow, DialogBack ), ButtonSelect )));
    Insert( New( PButton, Init('            Quit            ', Ex, 4, 17,ButtonFace, ButtonBack,
      Attr( Yellow, DialogBack ), ButtonSelect )));
  END;
END;

PROCEDURE TheEnd;
BEGIN
  RmWin;
  RmWin;
  Dispose( MainButtons, Done );
  Load8x16;
  Cursor( On );
  SetBlink( True );
  TextAttr := 14; Writeln;
  WriteCStr(80, False, 'Thank you for using LOADER by The GodFather');
  TextAttr := 7; Writeln;
  Halt(0);
END;


PROCEDURE ExtWrite(S1: STRING; Color1: Byte;
                   S2: STRING; Color2: Byte );
BEGIN
  TextAttr := Color1; Write( S1 );
  TextAttr := Color2; Write( S2 );
END;

PROCEDURE RunPrince;
BEGIN
  IF FindFile( 'PRINCE.EXE' ) THEN
  BEGIN
    MkWin( 20, 6, 43, 13, White, DialogBack, OKShad, CyrSingle, ' PRINCE OF PERSIA ');
    TextAttr := Attr( Yellow, DialogBack );
    Writeln(#13#10'             '#13#10);
    ExtWrite('     Shift+T  ', Attr( 14, DialogBack ), '-   '#13#10, Attr( 15, DialogBack ) );
    ExtWrite('     Shift+L  ', Attr( 14, DialogBack ), '-   '#13#10, Attr( 15, DialogBack ) );
    ExtWrite('     Shift+W  ', Attr( 14, DialogBack ), '-   '#13#10, Attr( 15, DialogBack ) );
    ExtWrite('     Shift+I  ', Attr( 14, DialogBack ), '-   '#13#10, Attr( 15, DialogBack ) );
    ExtWrite('     Shift+B  ', Attr( 14, DialogBack ), '-   '#13#10, Attr( 15, DialogBack ) );
    ExtWrite('           K  ', Attr( 14, DialogBack ), '-   '#13#10, Attr( 15, DialogBack ) );
    ExtWrite('           +  ', Attr( 14, DialogBack ), '-   '#13#10, Attr( 15, DialogBack ) );
    Pause;
    RmWin;
    Run( 'PRINCE.EXE', 'MEGAHIT' );
  END;
END;

PROCEDURE RunWingCommander;
VAR
  WC: PBCollection;
  Tmp: Byte;
  Name: STRING;

BEGIN
  Tmp := 0;
  WC := New( PBCollection, Init( 3, 1 ) );
  WITH WC^ DO
  BEGIN
    Insert( New( PButton, Init('     Wing Commander 1     ', ' ', 6, 2, ButtonFace, ButtonBack, 0, ButtonSelect )));
    Insert( New( PButton, Init('    Wing Commander 1 SO   ', ' ', 6, 4, ButtonFace, ButtonBack, 0, ButtonSelect )));
    Insert( New( PButton, Init('     Wing Commander 2     ', ' ', 6, 6, ButtonFace, ButtonBack, 0, ButtonSelect )));
    Insert( New( PButton, Init('           Quit           ', ' ', 6, 9, ButtonFace, ButtonBack, 0, ButtonSelect )));
  END;
  REPEAT
    MkWin( 20, 8, 39, 11, White, DialogBack, OKShad, cyrDouble, ' WING COMMANDER ');
    WC^.Choose( Tmp );
    RmWin;
    Tmp := WC^.ButtonNumb;
    IF NOT WC^.EscPressed THEN
    BEGIN
      CASE WC^.ButtonNumb OF
        0: Name := 'WC.EXE';
        1: Name := 'SO.EXE';
        2: Name := 'WC2.EXE';
        3: BEGIN
             Dispose( WC, Done );
             Exit
           END;
      END;
    END
    ELSE
    BEGIN
      Dispose( WC, Done );
      Exit
    END;
    IF FindFile( Name ) THEN
    BEGIN
      Dispose( WC, Done );
      Run( Name, 'Origin -k' );
    END;
  UNTIL (WC^.EscPressed) OR (Tmp = 3);
END;

PROCEDURE RunCommanderKeen;
VAR
  CK: PBCollection;
  Tmp: Byte;
  Lev: Byte;
  Max: Byte;
  Name: STRING;
  Level: STRING;

BEGIN
  Tmp := 0;
  CK := New( PBCollection, Init( 3, 1 ) );
  WITH CK^ DO
  BEGIN
    Insert( New( PButton, Init('     Commander Keen 4     ', ' ', 6, 2, ButtonFace, ButtonBack, 0, ButtonSelect )));
    Insert( New( PButton, Init('     Commander Keen 5     ', ' ', 6, 4, ButtonFace, ButtonBack, 0, ButtonSelect )));
    Insert( New( PButton, Init('     Commander Keen 6     ', ' ', 6, 6, ButtonFace, ButtonBack, 0, ButtonSelect )));
    Insert( New( PButton, Init('          Quit            ', ' ', 6, 9, ButtonFace, ButtonBack, 0, ButtonSelect )));
  END;
  REPEAT
    MkWin( 20, 8, 39, 11, White, DialogBack, OKShad, cyrDouble, ' COMMANDER KEEN 4-6 ');
    CK^.Choose( Tmp );
    RmWin;
    Tmp := CK^.ButtonNumb;
    IF NOT CK^.EscPressed THEN
    BEGIN
      CASE CK^.ButtonNumb OF
        0: BEGIN
             Name := 'KEEN4.EXE';
             Max  := 18;
           END;
        1: BEGIN
             Name := 'KEEN5.EXE';
             Max  := 13;
           END;
        2: BEGIN
             Name := 'KEEN6.EXE';
             Max  := 18;
           END;
        3: BEGIN
             Dispose( CK, Done );
             Exit
           END;
      END;
    END ELSE
        BEGIN
          Dispose( CK, Done );
          Exit
        END;
    IF FindFile( Name ) THEN
      IF DialogBox( 1, Max, Lev, ' COMMANDER KEEN '+Name[5]+' ' ) THEN
      BEGIN
        Str( Lev, Level );
        Dispose( CK, Done );
        Run( Name, ' /TEDLEVEL '+Level );
      END;
  UNTIL (CK^.EscPressed) OR (Tmp = 3);
END;

PROCEDURE RunWolfenstein3D;
VAR
  WB: PBCollection;
  Tmp: Byte;
  Level: Byte;
  LevelS: STRING;

BEGIN
  Tmp := 0;
  IF FindFile( 'WOLF6E.EXE' ) THEN
  BEGIN
    WB := New( PBCollection, Init( 7, 1 ) );
    WITH WB^ DO
    BEGIN
      Insert( New( PButton, Init('   Escape From Wolfenstein   ', ' ', 5, 2, ButtonFace, ButtonBack, 0, ButtonSelect )));
      Insert( New( PButton, Init('    Operetion: Eisenfaust    ', ' ', 5, 4, ButtonFace, ButtonBack, 0, ButtonSelect )));
      Insert( New( PButton, Init('      Die, Fuhrer, Die!      ', ' ', 5, 6, ButtonFace, ButtonBack, 0, ButtonSelect )));
      Insert( New( PButton, Init('        A Dark Secret        ', ' ', 5, 8, ButtonFace, ButtonBack, 0, ButtonSelect )));
      Insert( New( PButton, Init('     Trail Of The Madman     ', ' ', 5, 10,ButtonFace, ButtonBack, 0, ButtonSelect )));
      Insert( New( PButton, Init('        Confrontation        ', ' ', 5, 12,ButtonFace, ButtonBack, 0, ButtonSelect )));
      Insert( New( PButton, Init('            Quit             ', ' ', 5, 15,ButtonFace, ButtonBack, 0, ButtonSelect )));
    END;
    REPEAT
      MkWin( 21, 6, 39, 17, White, DialogBack, OKShad, cyrDouble, ' WOLFENSTEIN 3D ');
      WB^.Choose( Tmp );
      RmWin;
      Tmp := WB^.ButtonNumb;
      IF (WB^.EscPressed) OR (Tmp = 6) THEN
      BEGIN
        Dispose( WB, Done );
        Exit
      END
      ELSE IF DialogBox( 1, 10, Level, ' WOLFENSTEIN 3D ' ) THEN
      BEGIN
        Level := ( ( ( WB^.ButtonNumb ) * 10 ) + Level ) - 1;
        Str( Level, LevelS );
        Dispose( WB, Done );
        Run( 'WOLF6E.EXE', ' /TEDLEVEL ' + LevelS );
      END;
    UNTIL (WB^.EscPressed) OR (Tmp = 6);
  END;
END;

PROCEDURE RunSpearOfDestiny;
VAR
  Level: STRING;
  Lev: Byte;

BEGIN
  IF FindFile( 'WOLF.EXE' ) THEN
    IF DialogBox( 1, 21, Lev, ' SPEAR OF DESTINY ' ) THEN
    BEGIN
      Str( Lev-1, Level );
      Run( 'WOLF.EXE', ' /TEDLEVEL ' + Level );
    END;
END;

PROCEDURE RunDawnRider;
VAR
  Level: STRING;
  Lev: Byte;

BEGIN
  IF FindFile( 'DR.COM' ) THEN
    IF DialogBox( 1, 12, Lev, ' DAWN RIDER ' ) THEN
    BEGIN
      Str( Lev-1, Level );
      Run( 'DR.EXE', ' ' + Level );
    END;
END;

PROCEDURE DoomHint;
BEGIN
  MkWin( 12, 10, 58, 5, White, DialogBack, OKShad, CyrSingle, ' DOOM ');
  TextAttr := Attr( Yellow, DialogBack );
  Writeln;
  Writeln('            ');
  Writeln('    F1       PCX ');
  Pause;
  RmWin;
END;

PROCEDURE RunDoom;
VAR
  Doom: PBCollection;
  Doom1: PBCollection;
  DoomTmp: Byte;
  Tmp: Byte;
  Dummy: Byte;
  Level: STRING;
  Epizode: STRING;

BEGIN
  Doom    := New( PBCollection, Init( 6, 1 ) );
  DoomTmp := 0;
  WITH Doom^ DO
  BEGIN
    Insert( New( PButton, Init('          Doom 1           ', ' ', 6, 2, ButtonFace, ButtonBack, 0, ButtonSelect )));
    Insert( New( PButton, Init('          Doom 2           ', ' ', 6, 4, ButtonFace, ButtonBack, 0, ButtonSelect )));
    Insert( New( PButton, Init('           Quit            ', ' ', 6, 7, ButtonFace, ButtonBack, 0, ButtonSelect )));
  END;
  REPEAT
    MkWin( 20, 9, 39, 9, White, DialogBack, OKShad, cyrDouble, ' DOOM 1-2 ');
    Doom^.Choose( DoomTmp );
    RmWin;
    DoomTmp := Doom^.ButtonNumb;
    IF Doom^.EscPressed THEN DoomTmp := $FF;
    CASE DoomTmp OF
     0:
      BEGIN
        Tmp := 0;
        IF FindFile( 'DOOM.EXE' ) THEN
        BEGIN
          Doom1 := New( PBCollection, Init( 4, 1 ) );
          WITH Doom1^ DO
          BEGIN
            Insert( New( PButton, Init('   Knee - Deep in the Dead   ', ' ', 5, 2, ButtonFace, ButtonBack, 0, ButtonSelect )));
            Insert( New( PButton, Init('     The Shores of Hell      ', ' ', 5, 4, ButtonFace, ButtonBack, 0, ButtonSelect )));
            Insert( New( PButton, Init('          Inferno            ', ' ', 5, 6, ButtonFace, ButtonBack, 0, ButtonSelect )));
            Insert( New( PButton, Init('           Quit              ', ' ', 5, 9, ButtonFace, ButtonBack, 0, ButtonSelect )));
          END;
          REPEAT
            MkWin( 20, 9, 39, 11, White, DialogBack, OKShad, cyrDouble, ' DOOM 1 ');
            Doom1^.Choose( Tmp );
            RmWin;
            Tmp := Doom1^.ButtonNumb;
            Str( Tmp + 1, Epizode );
            IF (Doom1^.EscPressed) OR ( Tmp = 3 )
              THEN Dispose( Doom1, Done )
              ELSE
                IF DialogBox( 1, 9, Dummy, ' DOOM 1 ' + ' ' + Epizode + ' ') THEN
                BEGIN
                  Str( Dummy  , Level );
                  Str( Tmp + 1, Epizode );
                  Dispose( Doom1, Done );
                  DoomHint;
                  Run( 'DOOM.EXE', ' -DEVPARM -WART ' + Epizode + ' ' + Level );
                END;
          UNTIL (Doom1^.EscPressed) OR ( Tmp = 3 );
        END;
      END;
     1:
      BEGIN
        IF FindFile( 'DOOM2.EXE' ) THEN
          IF DialogBox( 1, 32, Dummy, ' DOOM 2 ' ) THEN
          BEGIN
            Str( Dummy, Level );
            DoomHint;
            Run( 'DOOM2.EXE', ' -DEVPARM -WARP ' + Level );
          END;
      END;
    END;
  UNTIL (Doom^.EscPressed) OR (DoomTmp = 2);
  Dispose( Doom, Done );
END;

BEGIN
  IF EgaVgaSystem THEN
  BEGIN
    OKShad       := True;
    ShadColor    := 136;
    DialogBack   := evDialogBack;
    ButtonBack   := evButtonBack;
    ButtonFace   := evButtonFace;
    ButtonSelect := evButtonSelect;
  END ELSE
  BEGIN
    OKShad       := False;
    DialogBack   := cDialogBack;
    ButtonBack   := cButtonBack;
    ButtonFace   := cButtonFace;
    ButtonSelect := cButtonSelect;
  END;
  InitDesktop;
  InitButtons;
  TempNumb := 0;
  REPEAT
    WITH MainButtons^ DO
    BEGIN
      MkWin( 6, 5, 70, 19, White, DialogBack, False, cyrDouble, '   ');
      Choose( TempNumb );
      RmWin;
      IF NOT EscPressed THEN
      BEGIN
        CASE ButtonNumb OF
         0: RunPrince;
         1: RunWingCommander;
         2: RunCommanderKeen;
         3: RunWolfenstein3D;
         4: RunSpearOfDestiny;
         5: RunDawnRider;
         6: RunDoom;
         7: TheEnd;
        END;
      END ELSE TheEnd;
      TempNumb := ButtonNumb;
    END;
  UNTIL True = False;
END.